import { LoginRequest } from '../domain/entities/request.interface';
import { User } from '../domain/entities/user.interface';

const mockUsers: User[] = [
  {
    id: 1,
    name: 'John Doe',
    username: 'johndoe',
    password: 'password1',
    roles: ['admin'],
  },
  {
    id: 2,
    name: 'Jane Doe',
    username: 'janedoe',
    password: 'password2',
    roles: ['user'],
  },
  {
    id: 3,
    name: 'Jim Brown',
    username: 'jimbrown',
    password: 'password3',
    roles: ['user', 'admin'],
  },
  {
    id: 4,
    name: 'Jane Smith',
    username: 'janesmith',
    password: 'password4',
    roles: ['user'],
  },
  {
    id: 5,
    name: 'John Smith',
    username: 'johnsmith',
    password: 'password5',
    roles: ['admin'],
  },
];

export class UserDataService {
  async login({ username, password }: LoginRequest): Promise<User | undefined> {
    const user = mockUsers.find((user) => {
      return user.username == username && user.password == password;
    });

    return user;
  }

  async users(): Promise<User[]> {
    return mockUsers;
  }
}
